
// ignore_for_file: public_member_api_docs, always_use_package_imports, non_constant_identifier_names


import 'iir_filter.dart';

class IIRFilterClass{


  IIRFilterClass(String filterSpec){
    filter_order = 2;

    if(filterSpec == IIRConstant.IIR_HPF_0_05){
      _numer1 = IIRCoefficient.IIR_HPF_0_05_NUMERATOR;
      _denom1 = IIRCoefficient.IIR_HPF_0_05_DENOMINATOR;
    }
    else if(filterSpec == IIRConstant.IIR_HPF_0_1){
      _numer1 = IIRCoefficient.IIR_HPF_0_1_NUMERATOR;
      _denom1 = IIRCoefficient.IIR_HPF_0_1_DENOMINATOR;
    }
    else if(filterSpec == IIRConstant.IIR_LPF_40){
      _numer1 = IIRCoefficient.IIR_LPF_40_NUMERATOR;
      _denom1 = IIRCoefficient.IIR_LPF_40_DENOMINATOR;
    }
    else if(filterSpec == IIRConstant.IIR_LPF_100){
      _numer1 = IIRCoefficient.IIR_LPF_100_NUMERATOR;
      _denom1 = IIRCoefficient.IIR_LPF_100_DENOMINATOR;
    }
    else if(filterSpec == IIRConstant.IIR_BSF_50){
      _numer1 = IIRCoefficient.IIR_BSF_50_NUMERATOR;
      _denom1 = IIRCoefficient.IIR_BSF_50_DENOMINATOR;
    }
    else if(filterSpec == IIRConstant.IIR_BSF_60){
      _numer1 = IIRCoefficient.IIR_BSF_60_NUMERATOR;
      _denom1 = IIRCoefficient.IIR_BSF_60_DENOMINATOR;
    }else{
      _numer1 = IIRCoefficient.IIR_BSF_60_NUMERATOR;
      _denom1 = IIRCoefficient.IIR_BSF_60_DENOMINATOR;
    }
  }

  late List<double> _numer1;
  late List<double> _denom1;
  final List<double> _x_val1 = [1, 0, 0];
  final List<double> _y_val1 = [0, 0, 0];
  int _sample_cnt1 = 0;
  int filter_order = 0;
  void setValue(double aa){
    _x_val1[1] = aa;
  }

  double apply(double inputVal){
    if (_sample_cnt1 == 2) {
      _x_val1[2] = inputVal;
      _y_val1[2] = 0;
      for(var ptr = 1; ptr < 3; ptr++){
        _y_val1[2] -= _denom1[ptr] * _y_val1[2 - ptr];
      }
      for(var ptr = 0; ptr < 3; ptr++){
        _y_val1[2] += _numer1[ptr] * _x_val1[2 - ptr];
      }

      for(var ptr = 0; ptr < 2; ptr++){
        _y_val1[ptr] = _y_val1[ptr + 1];
        _x_val1[ptr] = _x_val1[ptr + 1];
      }
    }else{
      _y_val1[_sample_cnt1] = inputVal;
      _x_val1[_sample_cnt1++] = inputVal;
      _y_val1[2] = 0;

      for(var ptr = 2; ptr > 2 - _sample_cnt1; ptr--){
        _y_val1[2] -= _denom1[ptr] * _y_val1[2 - ptr];
      }

      for(var ptr = 2; ptr > 2 - _sample_cnt1; ptr--){
        _y_val1[2] += _numer1[ptr] * _x_val1[2 - ptr];
      }
    }
    return _y_val1[2];
  }

  void clearValue() {
    for (var i = 0; i < 3; i++) {
      _x_val1[i] = 0;
      _y_val1[i] = 0;
    }
    _sample_cnt1 = 0;
  }
}
